using System;
using System.IO;
using System.Text;
using System.Security.Cryptography;

namespace CnBlogs.Helper.hBifTs
{

	#region AppEncrypt
	/// <summary>
	/// AppEncrypt : ,ṩ/Ļ.
	/// </summary>
	public abstract class AppEncrypt : IDisposable{
		#region Private variable & propery
		protected byte[] key;
		protected byte[] iv;

		protected ICryptoTransform CryptoTrans;
		protected SymmetricAlgorithm CryptObj;

		public byte[] Key{
			get{ return key;}
			set{ key = value;}
		}

		public byte[] IV
		{
			get{ return iv;}
			set{ iv = value;}
		}

		public AppEncrypt(byte[] Key,byte[] IV){
			key = Key;
			iv = IV;
		}
		#endregion

		#region Dispose

		public virtual void Dispose()
		{
			if( CryptoTrans != null)
			{
				CryptoTrans.Dispose();
				CryptoTrans = null;
			}
			if( CryptObj != null)
			{
				CryptObj.Clear();
				CryptObj = null;
			}
		}
		#endregion

		#region Common Function
		/// <summary>
		/// Sourceеݽм/,destination.
		/// </summary>
		/// <param name="source"></param>
		/// <param name="destination"></param>
		protected virtual void Translate(Stream source,ref Stream destination)
		{
			CryptoStream cstr = new CryptoStream(destination, CryptoTrans,CryptoStreamMode.Write);
			long read = 0;
			long length = source.Length;
			int len;
			byte[] bin = new byte[100];
			while( read < length)
			{
				len = source.Read(bin,0,bin.Length);
				cstr.Write(bin,0,len);
				read += len;
				cstr.Flush();
			}
			cstr.Close();
		}

		/// <summary>
		/// 
		/// </summary>
		public virtual MemoryStream Encrypt(Stream source){
			CryptoTrans = CryptObj.CreateEncryptor(key,iv);
			Stream mem = new MemoryStream();
			Translate(source,ref mem);
			return (MemoryStream)mem;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="source"></param>
		/// <param name="destination"></param>
		public virtual void Encrypt(Stream source,ref Stream destination){
			CryptoTrans = CryptObj.CreateEncryptor(key,iv);
			Translate(source,ref destination);
		}

		/// <summary>
		/// 
		/// </summary>
		public virtual Stream Dencrypt(Stream source){
			CryptoTrans = CryptObj.CreateDecryptor(key,iv);
			Stream mem = new MemoryStream();
			Translate(source ,ref mem);
			return (MemoryStream)mem;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="source"></param>
		/// <param name="destination"></param>
		public virtual void Dencrypt(Stream source,ref Stream destination){
			CryptoTrans = CryptObj.CreateDecryptor(key,iv);
			Translate(source,ref destination);
		}

		/// <summary>
		/// Կ
		/// </summary>
		/// <param name="Key"></param>
		/// <param name="IV"></param>
		public virtual void CreateRandomKey(out byte[] Key,out byte[] IV){
			CryptObj.GenerateKey();
			Key = CryptObj.Key;
			CryptObj.GenerateIV();
			IV = CryptObj.IV;
		}
		#endregion
	}
	#endregion

	#region DESEncrypt
	/// <summary>
	/// DESEncrypt : ṩDESܷʽ
	/// </summary>
	public class DESEncrypt : AppEncrypt
	{

		public DESEncrypt() : this( 
			new byte[]{0x23, 0x50, 0xA3, 0x51, 0xA, 0x32, 0x10, 0xE8},
			new byte[]{0x67, 0xDD, 0xF9, 0x7D, 0x19, 0x63, 0x8B, 0xBE}
			){}

		public DESEncrypt(byte[] Key,byte[] IV):base(Key,IV){			
			CryptObj = new DESCryptoServiceProvider();
		}
	}

	#endregion

	#region TripleDESEncrypt
	/// <summary>
	/// TripleDESEncrypt : ṩDESܷʽ
	/// </summary>
	public class TripleDESEncrypt : AppEncrypt
	{

		public TripleDESEncrypt() : this( 
			new byte[]{0x27,0xAA,0xA0,0xAB,0x43,0xEC,0x6E,0xEB,0xED,0xC6,0x37,0xD,0x81,0x48,0x2E,0x5F,0x2E,0xAB,0x81,0xAC,0xA8,0x85,0x2C,0x6,},
			new byte[]{0xCA,0x9E,0xD4,0xBF,0xCB,0x4A,0x6,0x3D,}
			){}

		public TripleDESEncrypt(byte[] Key,byte[] IV) : base(Key,IV){
			CryptObj = new TripleDESCryptoServiceProvider();
		}
	}
	#endregion

	#region RC2Encrypt
	/// <summary>
	/// RC2Encrypt : ṩRC2ܷʽ
	/// </summary>
	public class RC2Encrypt : AppEncrypt
	{

		public RC2Encrypt():this(
			new byte[]{0x43,0x89,0x35,0x68,0xE4,0xE9,0x84,0x39,0x1B,0xB2,0x18,0x40,0x4A,0x91,0x5F,0x52,},
			new byte[]{0xF9,0x29,0xEC,0x12,0x7A,0xE4,0xFC,0x87,}
			){}

		public RC2Encrypt(byte[] Key,byte[] IV) : base( Key,IV){
			CryptObj = new RC2CryptoServiceProvider();
		}
	}
	#endregion

	#region RijndaelEncrypt
	/// <summary>
	/// RijndaelEncrypt : ṩRijndaelܷʽ
	/// </summary>
	public class RijndaelEncrypt : AppEncrypt
	{

		public RijndaelEncrypt():this(
			new byte[]{0xB2,0xBC,0xEB,0xF5,0xA1,0xD9,0x7F,0x8A,0x37,0x95,0xE9,0xE7,0x42,0x81,0x9F,0xB,0x4C,
						  0xA,0x31,0x39,0xC9,0x25,0xFF,0xEA,0xFA,0x75,0x2,0xCB,0x16,0xCC,0xE5,0x13,},
			new byte[]{0xD1,0x93,0x9F,0x7A,0xD1,0xA9,0xCA,0x2D,0x5D,0xD9,0x8C,0xF0,0xBC,0xBA,0x40,0x10,}
			){}

		public RijndaelEncrypt(byte[] Key,byte[] IV):base(Key,IV){
			CryptObj = new RijndaelManaged();
		}
	}
	#endregion
}
