using System;
using System.IO;
using System.Text;
using CnBlogs.Helper.hBifTs;
using NUnit.Framework;


namespace CnBlogs.Helper.hBifTs.TestCases
{
	/// <summary>
	/// Summary description for TestAppEncrypt.
	/// </summary>
	/// 
	[TestFixture]
	public class TestAppEncrypt
	{
		private AppEncrypt enc;
		private MemoryStream mem;

		public TestAppEncrypt()
		{
		}

		[SetUp] public void Setup(){
			byte[] msg = Encoding.Unicode.GetBytes("hello,I got the new world,..");
			mem = new MemoryStream( msg);
		}

		[TearDown] public void TearDown(){
			mem.Close();
		}

		public void Common(){
			Stream dest = new MemoryStream();
			enc.Encrypt( mem,ref dest);
			Stream dest1 = new MemoryStream( ((MemoryStream)dest).ToArray());
			Stream dest2 = new MemoryStream();
			enc.Dencrypt( dest1,ref dest2);
			Assert.AreEqual( Encoding.Unicode.GetString(mem.ToArray()),Encoding.Unicode.GetString(((MemoryStream)dest2).ToArray()));
			Console.WriteLine( Encoding.Unicode.GetString(mem.ToArray()));
		}

		[Test] public void TestDES(){
			enc = new DESEncrypt();
			Common();
		}

		[Test] public void TestTripleDES(){
			enc = new TripleDESEncrypt();
			Common();
		}

		[Test] public void TestRC2(){
			enc = new RC2Encrypt();
			Common();
		}

		[Test] public void TestRijndael(){
			enc = new RijndaelEncrypt();
			Common();
		}
	}
}
